
#
# Copyright (c) 1999-2003 LAAS/CNRS
# All rights reserved.
#
# Redistribution  and  use in source   and binary forms,  with or without
# modification, are permitted provided that  the following conditions are
# met:
#
#   1. Redistributions  of  source code must  retain  the above copyright
#      notice, this list of conditions and the following disclaimer.
#   2. Redistributions in binary form must  reproduce the above copyright
#      notice,  this list of  conditions and  the following disclaimer in
#      the  documentation   and/or  other  materials   provided with  the
#      distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE  AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY  EXPRESS OR IMPLIED WARRANTIES, INCLUDING,  BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES   OF MERCHANTABILITY AND  FITNESS  FOR  A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO  EVENT SHALL THE AUTHOR OR  CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT,  INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING,  BUT  NOT LIMITED TO, PROCUREMENT  OF
# SUBSTITUTE  GOODS OR SERVICES;  LOSS   OF  USE,  DATA, OR PROFITS;   OR
# BUSINESS  INTERRUPTION) HOWEVER CAUSED AND  ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE  USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# This file was automagically generated.
# Manual editing not recommended. Changes will be overridden.
#

if { [lsearch [interp hidden] piloInstall] >= 0 } {
    interp expose {} piloInstall
}

proc ::piloInstall { name } {
    foreach rqst { "Init" "Move" "Turn" "GotoConfig" "SetDynamic" "GetDynamic" "ExecTraj" "ExecPosterTraj" "ExecAbsoluteBL" "Stop" "Slow" "MonLength" "PosRefPosRefPosterRead" "SpeedRefSpeedRefPosterRead" "BasicTrajTrajPosterRead"  } {
	interp alias {} ${name}::$rqst {} interp invoke {} pilo$rqst $name
    }
}

interp hide {} piloInstall




# Init ----------------------------------------------------------

if { [lsearch [interp hidden] piloInit] >= 0 } {
    interp expose {} piloInit
}
if { [lsearch [interp hidden] piloInitFormatOutput] >= 0 } {
    interp expose {} piloInitFormatOutput
}

proc ::piloInit { name args } {
    set format {}
    lappend format [list string "A POM_POS or POM_ME_POS poster type" "pomPos" ]

    return [ ::cs::rqstSend "${name}" "Init" \
	"** undocumented **" \
	"PILO_INIT_STR\n| char posPosterName\[64\]\n" \
	1 \
	$format \
	$args ]
}


proc ::piloInitFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} piloInit
interp hide {} piloInitFormatOutput





# Move ----------------------------------------------------------

if { [lsearch [interp hidden] piloMove] >= 0 } {
    interp expose {} piloMove
}
if { [lsearch [interp hidden] piloMoveFormatOutput] >= 0 } {
    interp expose {} piloMoveFormatOutput
}

proc ::piloMove { name args } {
    set format {}
    lappend format [list double "moveStr.dL" 0.0 ]
    lappend format [list int "moveStr.vPercent" 0 ]
    lappend format [list int "moveStr.accelPercent" 0 ]

    return [ ::cs::rqstSend "${name}" "Move" \
	"** undocumented **" \
	"PILO_MOVE_STR\n| double dL\n| int vPercent\n| int accelPercent\n" \
	3 \
	$format \
	$args ]
}


proc ::piloMoveFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} piloMove
interp hide {} piloMoveFormatOutput





# Turn ----------------------------------------------------------

if { [lsearch [interp hidden] piloTurn] >= 0 } {
    interp expose {} piloTurn
}
if { [lsearch [interp hidden] piloTurnFormatOutput] >= 0 } {
    interp expose {} piloTurnFormatOutput
}

proc ::piloTurn { name args } {
    set format {}
    lappend format [list double "turnStr.dTheta" 0.0 ]
    lappend format [list double "turnStr.rayon" 0.0 ]
    lappend format [list int "turnStr.wPercent" 0 ]
    lappend format [list int "turnStr.accelPercent" 0 ]

    return [ ::cs::rqstSend "${name}" "Turn" \
	"** undocumented **" \
	"PILO_TURN_STR\n| double dTheta\n| double rayon\n| int wPercent\n| int accelPercent\n" \
	4 \
	$format \
	$args ]
}


proc ::piloTurnFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} piloTurn
interp hide {} piloTurnFormatOutput





# GotoConfig ----------------------------------------------------------

if { [lsearch [interp hidden] piloGotoConfig] >= 0 } {
    interp expose {} piloGotoConfig
}
if { [lsearch [interp hidden] piloGotoConfigFormatOutput] >= 0 } {
    interp expose {} piloGotoConfigFormatOutput
}

proc ::piloGotoConfig { name args } {
    set format {}
    lappend format [list { "PILO_GOTO_CONFIG" "PILO_GOTO_POSITION" "PILO_SPIN_TOWARD_POSITION" } "gotoStr.gotoConfigMode" "" ]
    lappend format [list { "PILO_ABSOLUTE_TRAJ" "PILO_RELATIVE_TRAJ" } "gotoStr.absOrRelConfig" "" ]
    lappend format [list int "gotoStr.speedPercent" 0 ]
    lappend format [list int "gotoStr.accelPercent" 0 ]
    lappend format [list double "gotoStr.x" 0.0 ]
    lappend format [list double "gotoStr.y" 0.0 ]
    lappend format [list double "gotoStr.theta" 0.0 ]

    return [ ::cs::rqstSend "${name}" "GotoConfig" \
	"Spin or move the robot toward a cartesian configuration" \
	"PILO_GOTO_CONFIG_STR\n| PILO_GOTO_CONFIG_MODE gotoConfigMode\n| PILO_ABS_OR_REL absOrRelConfig\n| int speedPercent\n| int accelPercent\n| double x\n| double y\n| double theta\n" \
	7 \
	$format \
	$args ]
}


proc ::piloGotoConfigFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} piloGotoConfig
interp hide {} piloGotoConfigFormatOutput





# SetDynamic ----------------------------------------------------------

if { [lsearch [interp hidden] piloSetDynamic] >= 0 } {
    interp expose {} piloSetDynamic
}
if { [lsearch [interp hidden] piloSetDynamicFormatOutput] >= 0 } {
    interp expose {} piloSetDynamicFormatOutput
}

proc ::piloSetDynamic { name args } {
    set format {}
    lappend format [list int "dynamicParams.vMaxPercent" 0 ]
    lappend format [list int "dynamicParams.wMaxPercent" 0 ]
    lappend format [list int "dynamicParams.accelLinPercent" 0 ]
    lappend format [list int "dynamicParams.accelAngPercent" 0 ]

    return [ ::cs::rqstSend "${name}" "SetDynamic" \
	"** undocumented **" \
	"PILO_DYNAMIC_PARAMS\n| int vMaxPercent\n| int wMaxPercent\n| int accelLinPercent\n| int accelAngPercent\n" \
	4 \
	$format \
	$args ]
}


proc ::piloSetDynamicFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} piloSetDynamic
interp hide {} piloSetDynamicFormatOutput





# GetDynamic ----------------------------------------------------------

if { [lsearch [interp hidden] piloGetDynamic] >= 0 } {
    interp expose {} piloGetDynamic
}
if { [lsearch [interp hidden] piloGetDynamicFormatOutput] >= 0 } {
    interp expose {} piloGetDynamicFormatOutput
}

proc ::piloGetDynamic { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetDynamic" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::piloGetDynamicFormatOutput { list } {
    set format { {} status { } { dynamicParams { } vMaxPercent { } wMaxPercent { } accelLinPercent { } accelAngPercent } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} piloGetDynamic
interp hide {} piloGetDynamicFormatOutput





# ExecTraj ----------------------------------------------------------

if { [lsearch [interp hidden] piloExecTraj] >= 0 } {
    interp expose {} piloExecTraj
}
if { [lsearch [interp hidden] piloExecTrajFormatOutput] >= 0 } {
    interp expose {} piloExecTrajFormatOutput
}

proc ::piloExecTraj { name args } {
    set format {}
    lappend format [list int "trajStr.header.numTraj" 0 ]
    lappend format [list int "trajStr.header.nbSegs" 0 ]
    lappend format [list { "PILO_ARC_SEG" "PILO_LINE_SEG" } "trajStr.header.segType" "" ]
    lappend format [list { "PILO_ABSOLUTE_TRAJ" "PILO_RELATIVE_TRAJ" } "trajStr.header.absOrRel" "" ]
    lappend format [list double "trajStr.header.x0" 0.0 ]
    lappend format [list double "trajStr.header.y0" 0.0 ]
    lappend format [list double "trajStr.header.theta0" 0.0 ]
    lappend format [list double "trajStr.header.maxInitAngleDev" 0.0 ]
    lappend format [list double "trajStr.header.maxInitLengthDev" 0.0 ]
    for {set loop1(0) 0} { $loop1(0)<50 } { incr loop1(0)} {
    lappend format [list double "trajStr.seg\[$loop1(0)\].dTheta" 0.0 ]
    lappend format [list double "trajStr.seg\[$loop1(0)\].dL" 0.0 ]
    lappend format [list double "trajStr.seg\[$loop1(0)\].e" 0.0 ]
}

    return [ ::cs::rqstSend "${name}" "ExecTraj" \
	"** undocumented **" \
	"PILO_TRAJECTORY\n| PILO_TRAJ_HEADER\n| | int numTraj\n| | int nbSegs\n| | PILO_SEG_TYPE segType\n| | PILO_ABS_OR_REL absOrRel\n| | double x0\n| | double y0\n| | double theta0\n| | double maxInitAngleDev\n| | double maxInitLengthDev\n| PILO_SEGMENT\n| | double dTheta\n| | double dL\n| | double e\n" \
	159 \
	$format \
	$args ]
}


proc ::piloExecTrajFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} piloExecTraj
interp hide {} piloExecTrajFormatOutput





# ExecPosterTraj ----------------------------------------------------------

if { [lsearch [interp hidden] piloExecPosterTraj] >= 0 } {
    interp expose {} piloExecPosterTraj
}
if { [lsearch [interp hidden] piloExecPosterTrajFormatOutput] >= 0 } {
    interp expose {} piloExecPosterTrajFormatOutput
}

proc ::piloExecPosterTraj { name args } {
    set format {}
    lappend format [list string "trajPoster.posterName" "" ]

    return [ ::cs::rqstSend "${name}" "ExecPosterTraj" \
	"** undocumented **" \
	"PILO_TRAJ_POSTER\n| char posterName\[64\]\n" \
	1 \
	$format \
	$args ]
}


proc ::piloExecPosterTrajFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} piloExecPosterTraj
interp hide {} piloExecPosterTrajFormatOutput





# ExecAbsoluteBL ----------------------------------------------------------

if { [lsearch [interp hidden] piloExecAbsoluteBL] >= 0 } {
    interp expose {} piloExecAbsoluteBL
}
if { [lsearch [interp hidden] piloExecAbsoluteBLFormatOutput] >= 0 } {
    interp expose {} piloExecAbsoluteBLFormatOutput
}

proc ::piloExecAbsoluteBL { name args } {
    set format {}
    lappend format [list int "absBLStr.header.numTraj" 0 ]
    lappend format [list int "absBLStr.header.nbSegs" 0 ]
    lappend format [list { "PILO_ARC_SEG" "PILO_LINE_SEG" } "absBLStr.header.segType" "" ]
    lappend format [list { "PILO_ABSOLUTE_TRAJ" "PILO_RELATIVE_TRAJ" } "absBLStr.header.absOrRel" "" ]
    lappend format [list double "absBLStr.header.x0" 0.0 ]
    lappend format [list double "absBLStr.header.y0" 0.0 ]
    lappend format [list double "absBLStr.header.theta0" 0.0 ]
    lappend format [list double "absBLStr.header.maxInitAngleDev" 0.0 ]
    lappend format [list double "absBLStr.header.maxInitLengthDev" 0.0 ]
    lappend format [list double "absBLStr.finalDTheta" 0.0 ]
    for {set loop1(0) 0} { $loop1(0)<50 } { incr loop1(0)} {
    lappend format [list int "absBLStr.point\[$loop1(0)\].forward" 0 ]
    lappend format [list int "absBLStr.point\[$loop1(0)\].trigo" 0 ]
    lappend format [list double "absBLStr.point\[$loop1(0)\].x" 0.0 ]
    lappend format [list double "absBLStr.point\[$loop1(0)\].y" 0.0 ]
    lappend format [list double "absBLStr.point\[$loop1(0)\].e" 0.0 ]
}

    return [ ::cs::rqstSend "${name}" "ExecAbsoluteBL" \
	"** undocumented **" \
	"PILO_ABSOLUTE_BL\n| PILO_TRAJ_HEADER\n| | int numTraj\n| | int nbSegs\n| | PILO_SEG_TYPE segType\n| | PILO_ABS_OR_REL absOrRel\n| | double x0\n| | double y0\n| | double theta0\n| | double maxInitAngleDev\n| | double maxInitLengthDev\n| double finalDTheta\n| PILO_ABSOLUTE_REF\n| | int forward\n| | int trigo\n| | double x\n| | double y\n| | double e\n" \
	260 \
	$format \
	$args ]
}


proc ::piloExecAbsoluteBLFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} piloExecAbsoluteBL
interp hide {} piloExecAbsoluteBLFormatOutput





# Stop ----------------------------------------------------------

if { [lsearch [interp hidden] piloStop] >= 0 } {
    interp expose {} piloStop
}
if { [lsearch [interp hidden] piloStopFormatOutput] >= 0 } {
    interp expose {} piloStopFormatOutput
}

proc ::piloStop { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "Stop" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::piloStopFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} piloStop
interp hide {} piloStopFormatOutput





# Slow ----------------------------------------------------------

if { [lsearch [interp hidden] piloSlow] >= 0 } {
    interp expose {} piloSlow
}
if { [lsearch [interp hidden] piloSlowFormatOutput] >= 0 } {
    interp expose {} piloSlowFormatOutput
}

proc ::piloSlow { name args } {
    set format {}
    lappend format [list int "percentSpeed" 0 ]

    return [ ::cs::rqstSend "${name}" "Slow" \
	"** undocumented **" \
	"int percentSpeed\n" \
	1 \
	$format \
	$args ]
}


proc ::piloSlowFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} piloSlow
interp hide {} piloSlowFormatOutput





# MonLength ----------------------------------------------------------

if { [lsearch [interp hidden] piloMonLength] >= 0 } {
    interp expose {} piloMonLength
}
if { [lsearch [interp hidden] piloMonLengthFormatOutput] >= 0 } {
    interp expose {} piloMonLengthFormatOutput
}

proc ::piloMonLength { name args } {
    set format {}
    lappend format [list double "monLength" 0.0 ]

    return [ ::cs::rqstSend "${name}" "MonLength" \
	"** undocumented **" \
	"double monLength\n" \
	1 \
	$format \
	$args ]
}


proc ::piloMonLengthFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} piloMonLength
interp hide {} piloMonLengthFormatOutput





# PosRefPosRef ----------------------------------------------------------

if { [lsearch [interp hidden] piloPosRefPosRefPosterRead] >= 0 } {
    interp expose {} piloPosRefPosRefPosterRead
}
if { [lsearch [interp hidden] piloPosRefPosRefPosterFormatOutput] >= 0 } {
    interp expose {} piloPosRefPosRefPosterFormatOutput
}

proc ::piloPosRefPosRefPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "PosRefPosRef" \
	"GENPOS_CART_REF\n| int numRef\n| int tickPeriod\n| GENPOS_DATA_TYPE dataType\n| GENPOS_MOTION_DIRECTION backFlag\n| double x\n| double y\n| double theta\n| double v\n| double vt\n| double w\n| double vmax\n| double wmax\n| double linAccelMax\n| double angAccelMax\n" \
	$args ]
}


proc ::piloPosRefPosRefPosterFormatOutput { list } {
    set format { {} status { } { PosRef { } numRef { } tickPeriod { } dataType { } backFlag { } x { } y { } theta { } v { } vt { } w { } vmax { } wmax { } linAccelMax { } angAccelMax } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} piloPosRefPosRefPosterRead
interp hide {} piloPosRefPosRefPosterFormatOutput





# SpeedRefSpeedRef ----------------------------------------------------------

if { [lsearch [interp hidden] piloSpeedRefSpeedRefPosterRead] >= 0 } {
    interp expose {} piloSpeedRefSpeedRefPosterRead
}
if { [lsearch [interp hidden] piloSpeedRefSpeedRefPosterFormatOutput] >= 0 } {
    interp expose {} piloSpeedRefSpeedRefPosterFormatOutput
}

proc ::piloSpeedRefSpeedRefPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "SpeedRefSpeedRef" \
	"GENPOS_CART_SPEED\n| int numRef\n| int updatePeriod\n| double v\n| double vt\n| double w\n| double vmax\n| double wmax\n| double linAccelMax\n| double angAccelMax\n" \
	$args ]
}


proc ::piloSpeedRefSpeedRefPosterFormatOutput { list } {
    set format { {} status { } { SpeedRef { } numRef { } updatePeriod { } v { } vt { } w { } vmax { } wmax { } linAccelMax { } angAccelMax } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} piloSpeedRefSpeedRefPosterRead
interp hide {} piloSpeedRefSpeedRefPosterFormatOutput





# BasicTrajTraj ----------------------------------------------------------

if { [lsearch [interp hidden] piloBasicTrajTrajPosterRead] >= 0 } {
    interp expose {} piloBasicTrajTrajPosterRead
}
if { [lsearch [interp hidden] piloBasicTrajTrajPosterFormatOutput] >= 0 } {
    interp expose {} piloBasicTrajTrajPosterFormatOutput
}

proc ::piloBasicTrajTrajPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "BasicTrajTraj" \
	"PILO_TRAJECTORY\n| PILO_TRAJ_HEADER\n| | int numTraj\n| | int nbSegs\n| | PILO_SEG_TYPE segType\n| | PILO_ABS_OR_REL absOrRel\n| | double x0\n| | double y0\n| | double theta0\n| | double maxInitAngleDev\n| | double maxInitLengthDev\n| PILO_SEGMENT\n| | double dTheta\n| | double dL\n| | double e\n" \
	$args ]
}


proc ::piloBasicTrajTrajPosterFormatOutput { list } {
    set format { {} status { } { Traj { } { header { } numTraj { } nbSegs { } segType { } absOrRel { } x0 { } y0 { } theta0 { } maxInitAngleDev { } maxInitLengthDev } { 50 } { seg { } dTheta { } dL { } e } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} piloBasicTrajTrajPosterRead
interp hide {} piloBasicTrajTrajPosterFormatOutput


